"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var useForceRenders_1 = require("../hooks/useForceRenders");
var tools_1 = require("../utils/tools");
function createCapsule(registers) {
    /**
    * Helps wrap a component where you want to render by keyName
    * @param props Props Capsule
    * @example
    * <Capsule keyName='MyKeyName' index='1'>
    *  <MyComponent>
    * </Capsule>
    */
    function Capsule(props) {
        var _a = useForceRenders_1.useForceRender(), forceRender = _a[1];
        function setRegister() {
            var encapsulation = {
                keyName: props.keyName,
                index: props.index,
                render: forceRender,
                props: props.props
            };
            registers.set(tools_1.__keyNameIndex__(props.keyName, props.index), encapsulation);
        }
        function deleteRegister() {
            registers.delete(tools_1.__keyNameIndex__(props.keyName, props.index));
        }
        react_1.useEffect(function () {
            setRegister();
            return function () {
                deleteRegister();
            };
        }, []);
        setRegister();
        return react_1.default.createElement(react_1.Fragment, null, props.children(props.props));
    }
    return Capsule;
}
exports.default = createCapsule;
